//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include <dir.h> // fonction fnsplit
#include "Unit1.h"
#include "Unit2.h"
#include "Unit3.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CPort"
#pragma link "CPortCtl"
#pragma resource "*.dfm"

// (C) Fabrice Sincre ; septembre 2007
// Borland Builder 5
// Composant ComPort

int j=0;
double y;
double tmin = 8.0 , tmin0 = 8.0;
double tmax = 40.0 ,tmax0 = 40.0;
double sdiv = 720.0 , sdiv0 = 720.0 ;
double samplingperiod = 1.5 , samplingperiod0 = 1.5 ;
double deltat ,deltas ;

double temperature_moy = 20.0 ; // moyenne entre deux mises  jour de l'affichage
double temperature_cumul = 0.0;
int nb_mesures = 0;

double temperature_actuelle = 20.0;

AnsiString temoinreception = " "; // clignotement d'une toile (*) dans la bote "temprature actuelle"
AnsiString temp_lue ="20,0";
bool seconde = true,  seconde0 = true;
bool minute = false,  minute0 = false;
bool heure = false,  heure0 = false;
bool jour = false,  jour0 = false;

char tabulation ='\t';  // tabulation horizontale, code ASCII 0x09
char retour ='\r';      // retour chariot, code ASCII 0x0D
char saut ='\n';        // saut  la ligne, code ASCII 0x0A
int iFileHandle;
bool sauvegardeencours = false ;
AnsiString time0, timebak ="";

unsigned char tableau[3];
        // TX (RS232)  3 octets transmis vers le PIC
        // 1er octet transmis: tableau[0]
        // 2me octet transmis : tableau[1]
        // 3me octet transmis : tableau[2]

// instruction          1er octet (code instruction)    2me octet (donnes)    3me octet (donnes)

// Read Temperature     0xAA                            0x00 non utilise       0x00 non utilise
// Read TH              0xA1                            0x00 non utilise       0x00 non utilise
// Read TL              0xA2                            0x00 non utilise       0x00 non utilise
// Write TH             0x01                            (0000000 D8)            (D7 ... D0)
// Write TL             0x02                            (0000000 D8)            (D7 ... D0)

int D[9]; // 9 bits (D[8] ... D[0]) : temprature numrique en complment  deux

int flagReadTemperature = 0; // drapeau instruction Read Temperature
int flagReadTH =0;
int flagReadTL =0;
int flagWriteTH =0;
int flagWriteTL =0;

double TH = 15.0;
double TL = 10.0;

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
//clear screen

Image1->Canvas->Brush ->Color = clWhite;
Image1->Canvas->FillRect(Rect(0,0,480,320));

// grilles
Image1->Canvas->Pen->Color = clBlue; // couleur du trait
Image1->Canvas->Pen->Width = 1; // largeur du trait
Image1->Canvas->Pen->Style = psDot	; // Style du trait (pointill)

for (int i = 0 ; i<9 ; i++)       // 8 lignes
{
    Image1->Canvas->MoveTo(0 , 40*i);
    Image1->Canvas->LineTo(480 , 40*i);
}
for (int i = 0 ; i<13 ; i++)   // 12 colonnes
{
    Image1->Canvas->MoveTo(40*i , 0);
    Image1->Canvas->LineTo(40*i , 320);
}
Image1->Canvas->MoveTo(-100 , 160);

}

//---------------------------------------------------------------------------
void grapheON ()
{
Form1->Timer3->Enabled=false;
try
{
seconde = Form1->RadioButton4->Checked ;
minute = Form1->RadioButton1->Checked ;
heure =  Form1->RadioButton2->Checked ;
jour =  Form1->RadioButton3->Checked ;

tmax =(Form1->Edit1->Text).ToDouble(); //conversion de AnsiString en Double
tmin =(Form1->Edit2->Text).ToDouble(); //conversion de AnsiString en Double
sdiv =(Form1->Edit3->Text).ToDouble(); //conversion de AnsiString en Double
}
catch(...)
{
tmax = tmax0;
tmin = tmin0;
sdiv = sdiv0;
seconde = seconde0;
minute = minute0;
heure = heure0;
jour = jour0;
Form1->Edit1->Text = FloatToStrF(tmax,ffFixed,15,2);
Form1->Edit2->Text = FloatToStrF(tmin,ffFixed,15,2);
Form1->Edit3->Text = FloatToStrF(sdiv,ffFixed,15,2);
Form1->RadioButton4->Checked = seconde ;
Form1->RadioButton1->Checked = minute ;
Form1->RadioButton2->Checked = heure;
Form1->RadioButton3->Checked = jour;
Application->MessageBox("Valeur non valide !","Erreur 01",MB_OK);
}

samplingperiod  = sdiv / 480.0 ;    // en s
if (Form1->RadioButton1->Checked == true) samplingperiod = samplingperiod*60.0 ;
if (Form1->RadioButton2->Checked == true) samplingperiod = samplingperiod*3600.0 ;
if (Form1->RadioButton3->Checked == true) samplingperiod = samplingperiod*86400.0 ;

if ((tmax <= tmin) || (samplingperiod < 1.0))
{
        if (tmax <= tmin) Application->MessageBox ("T max doit tre suprieure  T min !","Erreur 02",MB_OK);
        if (samplingperiod < 1.0) Application->MessageBox("La priode doit tre suprieure  480 secondes !","Erreur 03",MB_OK);
        tmax = tmax0;
        tmin = tmin0;
        sdiv = sdiv0;
        samplingperiod =  samplingperiod0;
        seconde = seconde0;
        minute = minute0;
        heure = heure0;
        jour = jour0;
}

tmax0 = tmax;
tmin0 = tmin;
sdiv0 = sdiv;
samplingperiod0 =  samplingperiod;
seconde0 = seconde;
minute0 = minute;
heure0 = heure;
jour0 = jour;

deltat = (tmax - tmin)/8.0 ;
deltas =  sdiv /12.0 ;

Form1->Timer3 -> Interval = samplingperiod*1000.0;
Form1->Labelsamplingperiod -> Caption = FloatToStrF(samplingperiod,ffFixed,15,3) + " s";
Form1->Edit1->Text = FloatToStrF(tmax,ffFixed,15,2);
Form1->Edit2->Text = FloatToStrF(tmin,ffFixed,15,2);
Form1->Edit3->Text = FloatToStrF(sdiv,ffFixed,15,2);
Form1->RadioButton4->Checked = seconde ;
Form1->RadioButton1->Checked = minute ;
Form1->RadioButton2->Checked = heure;
Form1->RadioButton3->Checked = jour;

Form1->Labelx0 -> Caption = FloatToStrF(tmin,ffFixed,15,2) + "C";
Form1->Labelx1 -> Caption = FloatToStrF(tmin + 1.0*deltat,ffFixed,15,2)+ "C";
Form1->Labelx2 -> Caption = FloatToStrF(tmin + 2.0*deltat,ffFixed,15,2)+ "C";
Form1->Labelx3 -> Caption = FloatToStrF(tmin + 3.0*deltat,ffFixed,15,2)+ "C";
Form1->Labelx4 -> Caption = FloatToStrF(tmin + 4.0*deltat,ffFixed,15,2)+ "C";
Form1->Labelx5 -> Caption = FloatToStrF(tmin + 5.0*deltat,ffFixed,15,2)+ "C";
Form1->Labelx6 -> Caption = FloatToStrF(tmin + 6.0*deltat,ffFixed,15,2)+ "C";
Form1->Labelx7 -> Caption = FloatToStrF(tmin + 7.0*deltat,ffFixed,15,2)+ "C";
Form1->Labelx8 -> Caption = FloatToStrF(tmin + 8.0*deltat,ffFixed,15,2)+ "C";

Form1->Labelt1 -> Caption = FloatToStrF(1.0*deltas,ffFixed,15,2);
Form1->Labelt2 -> Caption = FloatToStrF(2.0*deltas,ffFixed,15,2);
Form1->Labelt3 -> Caption = FloatToStrF(3.0*deltas,ffFixed,15,2);
Form1->Labelt4 -> Caption = FloatToStrF(4.0*deltas,ffFixed,15,2);
Form1->Labelt5 -> Caption = FloatToStrF(5.0*deltas,ffFixed,15,2);
Form1->Labelt6 -> Caption = FloatToStrF(6.0*deltas,ffFixed,15,2);
Form1->Labelt7 -> Caption = FloatToStrF(7.0*deltas,ffFixed,15,2);
Form1->Labelt8 -> Caption = FloatToStrF(8.0*deltas,ffFixed,15,2);
Form1->Labelt9 -> Caption = FloatToStrF(9.0*deltas,ffFixed,15,2);
Form1->Labelt10 -> Caption = FloatToStrF(10.0*deltas,ffFixed,15,2);
Form1->Labelt11 -> Caption = FloatToStrF(11.0*deltas,ffFixed,15,2);
Form1->Labelt12 -> Caption = FloatToStrF(12.0*deltas,ffFixed,15,2);

//clear

Form1->Image1->Canvas->Brush ->Color = clWhite;
Form1->Image1->Canvas->FillRect(Rect(0,0,480,320));

// grilles
Form1->Image1->Canvas->Pen->Color = clBlue; // couleur du trait
Form1->Image1->Canvas->Pen->Width = 1; // largeur du trait
Form1->Image1->Canvas->Pen->Style = psDot	; // Style du trait (pointill)

for (int i = 0 ; i<9 ; i++)       // 8 lignes
{
        Form1->Image1->Canvas->MoveTo(0 , 40*i);
        Form1->Image1->Canvas->LineTo(480 , 40*i);
}
for (int i = 0 ; i<13 ; i++)   // 12 colonnes
{
        Form1->Image1->Canvas->MoveTo(40*i , 0);
        Form1->Image1->Canvas->LineTo(40*i , 320);
}

Form1->Image1->Canvas->MoveTo(-100 , 160);
j=0 ;
Form1->Timer3->Enabled=true;
return;
}

//---------------------------------------------------------------------------
void ReadTH(void)
{
tableau[0]= 0xA1;
tableau[1]= 0x00;
tableau[2]= 0x00;
flagReadTH = 1;

// transmission des 3 octets (liaison RS232)

// 1er octet transmis: tableau[0]
// 2me octet transmis : tableau[1]
// 3me octet transmis : tableau[2]

Form1->ComPort1->Write(tableau, 3); // Ecrit les 3 octets sur le port srie
return;
}

//---------------------------------------------------------------------------
void ReadTL(void)
{
tableau[0]= 0xA2;
tableau[1]= 0x00;
tableau[2]= 0x00;
flagReadTL = 1;
// transmission des 3 octets (liaison RS232)

// 1er octet transmis: tableau[0]
// 2me octet transmis : tableau[1]
// 3me octet transmis : tableau[2]

Form1->ComPort1->Write(tableau, 3); // Ecrit les 3 octets sur le port srie
return;
}



//---------------------------------------------------------------------------

double bintemp (int *data)
{
// conversion de (D8 ... D0) en complment  2 (tableau D[9])
// en temprature (en C)

// 0 1111 1010 = 250 = +125C (max)
// 0 0000 0001 = 1 = +0,5C
// 0 0000 0000 = 0 = 0C
// 1 1111 1111 = -1 = - 0,5 C
// 1 1001 0010 = -110 = -55C (min)

// D8 = bit de signe
// D8 = 0 : temperature positive
// D8 = 1 : temperature ngative
// 1 1001 0010
// on complmente : 0110 1101 = 109
// +1 = 110 = -55 C

double temperature;

if (data[8] == 0)
{
temperature = 128*data[7] + 64*data[6] + 32*data[5] + 16*data[4] + 8*data[3] + 4*data[2] + 2*data[1] + data[0];
temperature = temperature*0.5;
}
else
{
temperature = 128*(1-data[7]) + 64*(1-data[6]) + 32*(1-data[5]) + 16*(1-data[4]) + 8*(1-data[3]) + 4*(1-data[2]) + 2*(1-data[1]) +(1- data[0]);
temperature = - (temperature + 1)*0.5;
}

return temperature;
}

//---------------------------------------------------------------------------

void tempbin(double temperature)
{
// conversion de la temperature (en C)
// en un nombre binaire en complment  2
// (dans la variable globale D[9])

temperature = 2*temperature;
int itemperature;
itemperature = temperature;

if (itemperature >=0)
{
        D[8]=0;   // bit de signe

        for (int i=0 ; i < 8 ; i++)
        {
                D[i] = itemperature % 2 ; // reste de la division
                itemperature = itemperature /2 ;
        }
}

else
{
        D[8]=1;      // bit de signe
        itemperature = -itemperature ;
        itemperature = 256 -itemperature;
        for (int i=0 ; i < 8 ; i++)
        {
                D[i] = itemperature % 2 ; // reste de la division
                itemperature = itemperature /2 ;
        }
}

return;
}

//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
// bouton Valider
grapheON();

}
//---------------------------------------------------------------------------


void __fastcall TForm1::Timer3Timer(TObject *Sender)
{

j++;
if (j>480)
{
        // on efface le demi cran gauche
        Image1->Canvas->Brush ->Color = clWhite;
        Image1->Canvas->FillRect(Rect(0,0,240,320));
        // grilles
        Image1->Canvas->Pen->Color = clBlue; // couleur du trait
        Image1->Canvas->Pen->Width = 1; // largeur du trait
        Image1->Canvas->Pen->Style = psDot	; // Style du trait (pointill)

        for (int i = 0 ; i<9 ; i++)       // 8 lignes
        {
                Image1->Canvas->MoveTo(0 , 40*i);
                Image1->Canvas->LineTo(480 , 40*i);
        }
        for (int i = 0 ; i<13 ; i++)   // 12 colonnes
        {
                Image1->Canvas->MoveTo(40*i , 0);
                Image1->Canvas->LineTo(40*i , 320);
        }
        j=1 ;
        Image1->Canvas->MoveTo(0 , y);
}
if (j==240)
{
        // on efface le demi cran droit
        Image1->Canvas->Brush ->Color = clWhite;
        Image1->Canvas->FillRect(Rect(240,0,480,320));
        // grilles
        Image1->Canvas->Pen->Color = clBlue; // couleur du trait
        Image1->Canvas->Pen->Width = 1; // largeur du trait
        Image1->Canvas->Pen->Style = psDot	; // Style du trait (pointill)

        for (int i = 0 ; i<9 ; i++)       // 8 lignes
        {
                Image1->Canvas->MoveTo(0 , 40*i);
                Image1->Canvas->LineTo(480 , 40*i);
        }
        for (int i = 0 ; i<13 ; i++)   // 12 colonnes
        {
                Image1->Canvas->MoveTo(40*i , 0);
                Image1->Canvas->LineTo(40*i , 320);
        }
        Image1->Canvas->MoveTo(239 , y);

}
Image1->Canvas->Pen->Color = clRed; // couleur du trait
Image1->Canvas->Pen->Width = 2; // largeur du trait

if (nb_mesures != 0) temperature_moy = temperature_cumul / nb_mesures;

y =  -320.0*(temperature_moy - tmax)/(tmax - tmin);
Image1->Canvas->LineTo(j,y);

if (sauvegardeencours == true)
{
        // mise  jour fichier de sauvegarde
        time0 = TimeToStr(Time());
        if (time0 != timebak)   // une sauvegarde par seconde max.
        {
                FileWrite(iFileHandle, DateToStr(Date()).c_str(), DateToStr(Date()).Length());
                FileWrite(iFileHandle, &tabulation, 1);
                FileWrite(iFileHandle, time0.c_str(), time0.Length());
                FileWrite(iFileHandle, &tabulation, 1);
                FileWrite(iFileHandle, FloatToStrF(temperature_moy ,ffFixed,15,2).c_str(), FloatToStrF(temperature_moy,ffFixed,15,2).Length());
                FileWrite(iFileHandle, &retour, 1);
                FileWrite(iFileHandle, &saut, 1);
        }
        timebak = time0;
}

nb_mesures = 0;
temperature_cumul = 0.0;
temperature_moy = 20.0;

}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button7Click(TObject *Sender)
{
ComPort1->Connected=true;  // ouverture du port
Button7->Enabled=false;
Button8->Enabled=true;
Button6->Enabled=false;

Timer1 ->Enabled =true;
ButtonSauvegarde->Enabled=true;
sauvegardeencours = false;

GroupBox1 -> Enabled=true;
GroupBoxThermostat ->Enabled=true;

//clear

Image1->Canvas->Brush ->Color = clWhite;
Image1->Canvas->FillRect(Rect(0,0,480,320));


// grilles
Image1->Canvas->Pen->Color = clBlue; // couleur du trait
Image1->Canvas->Pen->Width = 1; // largeur du trait
Image1->Canvas->Pen->Style = psDot	; // Style du trait (pointill)

for (int i = 0 ; i<9 ; i++)       // 8 lignes
{
        Image1->Canvas->MoveTo(0 , 40*i);
        Image1->Canvas->LineTo(480 , 40*i);
}
for (int i = 0 ; i<13 ; i++)   // 12 colonnes
{
        Image1->Canvas->MoveTo(40*i , 0);
        Image1->Canvas->LineTo(40*i , 320);
}
Image1->Canvas->MoveTo(-100 , 160);
j = 0;
grapheON();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button8Click(TObject *Sender)
{
ComPort1->Connected=false;  // fermeture du port
Button7->Enabled=true;
Button8->Enabled=false;
Button6->Enabled=true;
Timer3->Enabled=false;
GroupBox1 -> Enabled=false;
GroupBoxThermostat ->Enabled=false;
ButtonSauvegarde->Enabled = false ;

if (sauvegardeencours == true)
{
        FileClose(iFileHandle);
        sauvegardeencours = false;
}

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComPort1RxChar(TObject *Sender, int Count)
{
// on arrive ici quand on reoit des donnes du port COM

/*
instruction             1er octet (donnes)     2me octet (donnes)

Read Temperature        (0000000 D8)            (D7 ... D0)
Read TH                 (0000000 D8)            (D7 ... D0)
Read TL                 (0000000 D8)            (D7 ... D0)
Write TH                0x00 (non utilis)      0x00 (non utilis)
Write TL                0x00 (non utilis)      0x00 (non utilis)
*/

try
{

unsigned char *datarecu = new unsigned char [Count];
ComPort1->Read(datarecu, Count);
// Lit "Count" octet(s) prsent(s) dans le buffer d'entre et le(s) place dans "datarecu"
// Normalement, on reoit deux octets du PIC

if (flagReadTH == 1)
{
        D[8] = datarecu[0];

        for (int i=0 ; i < 8 ; i++)
        {
                D[i] = datarecu[1] % 2 ; // reste de la division
                datarecu[1] = datarecu[1] /2 ;
        }
        EditTH ->Text =  bintemp (D);
        TH = bintemp (D);

}
if (flagReadTL == 1)
{
        D[8] = datarecu[0];

        for (int i=0 ; i < 8 ; i++)
        {
                D[i] = datarecu[1] % 2 ; // reste de la division
                datarecu[1] = datarecu[1] /2 ;
        }
        EditTL ->Text =  bintemp (D);
        TL = bintemp (D);
}

if (flagReadTemperature == 1)
{
        D[8] = datarecu[0];

        for (int i=0 ; i < 8 ; i++)
        {
                D[i] = datarecu[1] % 2 ; // reste de la division
                datarecu[1] = datarecu[1] /2 ;
        }
        temperature_actuelle =  bintemp (D);
        // calcul de la valeur moyenne de la temperature
        nb_mesures++;
        temperature_cumul =  temperature_cumul + temperature_actuelle;

        // tmoin de rception
        if (temoinreception == " ") temoinreception = "*";
        else temoinreception = " ";
}


if (flagWriteTH == 1)
{
        if ((datarecu[0] != 0x00) || (datarecu[1] != 0x00))
        {
                Application->MessageBox("Erreur de rception !","Erreur 04",MB_OK);
        }

}

if (flagWriteTL == 1)
{
        if ((datarecu[0] != 0x00) || (datarecu[1] != 0x00))
        {
                Application->MessageBox("Erreur de rception !","Erreur 05",MB_OK);
        }

}

flagReadTemperature = 0; // drapeau instruction Read Temperature
flagReadTH =0;
flagReadTL =0;
flagWriteTH =0;
flagWriteTL =0;

delete [] datarecu;
datarecu = NULL;
}

catch(...)
{
Application->MessageBox("Erreur de rception !","Erreur 06",MB_OK);
}


}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)
{
ComPort1->ShowSetupDialog();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
// on arrive ici toutes les 1000 ms

if (ComPort1->Connected==true)
{
        // lecture de la temprature (instruction Read Temperature)
        tableau[0]= 0xAA;
        tableau[1]= 0x00;
        tableau[2]= 0x00;
        flagReadTemperature = 1;
        ComPort1->Write(tableau, 3); // Ecrit les 3 octets sur le port srie
}

// mise  jour affichage de la temprature actuelle + tmoin de rception clignotant
Label6temp -> Caption = FloatToStrF(temperature_actuelle,ffFixed,15,1) + " C " + temoinreception;
// affichage de l'heure courante
Label7time->Caption=TimeToStr(Time());   // AnsiString  hh:mm:ss
Label7date->Caption=DateToStr(Date());   // AnsiString 
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonSauvegardeClick(TObject *Sender)
{
// sauvegarde dans un fichier
if (sauvegardeencours == false)
{
AnsiString entete ="Suivi de temprature" ;
AnsiString entete0 ="(C) Fabrice Sincre" ;
AnsiString entete1 ="Date       ";
AnsiString entete2 ="Heure      ";
AnsiString entete3 ="Temprature (C)" ;
char szFileName[100];

int iLength;
if (SaveDialog1->Execute())
{
        if (FileExists(SaveDialog1->FileName))
        {
                fnsplit(SaveDialog1->FileName.c_str(), 0, 0, szFileName, 0);
                strcat(szFileName, ".BAK");
                RenameFile(SaveDialog1->FileName, szFileName);
        }
        iFileHandle = FileCreate(SaveDialog1->FileName);

        FileWrite(iFileHandle, entete.c_str(), entete.Length());
        FileWrite(iFileHandle, &retour, 1);
        FileWrite(iFileHandle, &saut, 1);
        FileWrite(iFileHandle, entete0.c_str(), entete0.Length());
        FileWrite(iFileHandle, &retour, 1);
        FileWrite(iFileHandle, &saut, 1);
        FileWrite(iFileHandle, &retour, 1);
        FileWrite(iFileHandle, &saut, 1);
        FileWrite(iFileHandle, entete1.c_str(), entete1.Length());
        FileWrite(iFileHandle, &tabulation, 1);
        FileWrite(iFileHandle, entete2.c_str(), entete2.Length());
        FileWrite(iFileHandle, &tabulation, 1);
        FileWrite(iFileHandle, entete3.c_str(), entete3.Length());
        FileWrite(iFileHandle, &retour, 1);
        FileWrite(iFileHandle, &saut, 1);
        FileWrite(iFileHandle, &retour, 1);
        FileWrite(iFileHandle, &saut, 1);

        sauvegardeencours = true ;
        ButtonSauvegarde->Enabled=false;
}
}
}


//---------------------------------------------------------------------------


void __fastcall TForm1::ButtonWriteTHClick(TObject *Sender)
{
try
{
double THbak = TH;
TH = EditTH ->  Text.ToDouble();

if ((TH < -55.0) || (TH > 125.0))
{
        Application->MessageBox("La temprature TH doit tre comprise\nentre -55 et +125 C","Erreur 07",MB_OK);
        EditTH ->  Text = THbak;
        TH = THbak;
        ReadTH();
        return;
}
int iTH;
iTH = 2.0*TH;

if ((2.0*TH - iTH) != 0)
{
        Application->MessageBox("La temprature TH doit tre un multiple\nde 0,5 C","Erreur 08",MB_OK);
        EditTH ->  Text = THbak;
        TH = THbak;
        ReadTH();
        return;
}
if (TL >= TH)
{
        Application->MessageBox("La temprature TL doit tre\ninfrieure  la temprature TH","Erreur 09",MB_OK);
        EditTH ->  Text = THbak;
        TH = THbak;
        ReadTH();
        return;
}
// conversion en binaire
tempbin(TH);

tableau[0]= 0x01;
tableau[1]= D[8];
tableau[2] = 128*D[7] + 64*D[6] + 32*D[5] + 16*D[4] + 8*D[3] + 4*D[2] + 2*D[1] + D[0];

flagWriteTH = 1;
// transmission des 3 octets (liaison RS232)

// 1er octet transmis: tableau[0]
// 2me octet transmis : tableau[1]
// 3me octet transmis : tableau[2]

ComPort1->Write(tableau, 3); // Ecrit les 3 octets sur le port srie
}
catch(...)
{
Application->MessageBox("Valeur non valide !","Erreur 10",MB_OK);
ReadTH();
}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonWriteTLClick(TObject *Sender)
{
try
{

double TLbak = TL;
TL = EditTL ->  Text.ToDouble();

if ((TL < -55.0) || (TL > 125.0))
{
        Application->MessageBox("La temprature TL doit tre comprise\nentre -55 et +125 C","Erreur 11",MB_OK);
        EditTL ->  Text = TLbak;
        TL = TLbak;
        ReadTL();
        return;
}
int iTL;
iTL = 2.0*TL;

if ((2.0*TL - iTL) != 0)
{
        Application->MessageBox("La temprature TL doit tre un multiple\nde 0,5 C","Erreur 12",MB_OK);
        EditTL ->  Text = TLbak;
        TL = TLbak;
        ReadTL();
        return;
}
if (TL >= TH)
{
        Application->MessageBox("La temprature TL doit tre\ninfrieure  la temprature TH","Erreur 13",MB_OK);
        EditTL ->  Text = TLbak;
        TL = TLbak;
        ReadTL();
        return;
}

// conversion en binaire
tempbin(TL);

tableau[0]= 0x02;
tableau[1]= D[8];
tableau[2] = 128*D[7] + 64*D[6] + 32*D[5] + 16*D[4] + 8*D[3] + 4*D[2] + 2*D[1] + D[0];

flagWriteTL = 1;
// transmission des 3 octets (liaison RS232)

// 1er octet transmis: tableau[0]
// 2me octet transmis : tableau[1]
// 3me octet transmis : tableau[2]

ComPort1->Write(tableau, 3); // Ecrit les 3 octets sur le port srie
}
catch(...)
{
Application->MessageBox("Valeur non valide !","Erreur 14",MB_OK);
ReadTL();
}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonReadTHClick(TObject *Sender)
{
ReadTH();        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonReadTLClick(TObject *Sender)
{
ReadTL();        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonSchema1Click(TObject *Sender)
{
Form2shema1-> ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonSchema2Click(TObject *Sender)
{
Form3schema2-> ShowModal();
}
//---------------------------------------------------------------------------

